﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Net.Http;
using System.Net.Http.Headers;
using System.IO;
using System.Diagnostics;
using Newtonsoft.Json.Linq;


namespace esl
{
    class MortageLoanApplicationRest
    {
        public static void start()
        {
            string apiKey = "YOUR_API_KEY";
            string url = "https://sandbox.esignlive.com/api";

            string jsonString = "{\"type\":\"PACKAGE\",\"status\":\"DRAFT\",\"roles\":[{\"id\":\"Signer1\",\"type\":\"SIGNER\",\"signers\":[{\"email\":\"mail32@mailinator.com\",\"firstName\":\"John\",\"lastName\":\"Smith\",\"id\":\"Signer1\"}]},{\"id\":\"Signer2\",\"type\":\"SIGNER\",\"signers\":[{\"email\":\"mail33@mailinator.com\",\"firstName\":\"Patty\",\"lastName\":\"Galant\",\"id\":\"Signer2\"}]}],\"name\":\"Mortgage Loan Application #1143216218\",\"documents\":[{\"fields\":[{\"value\":\"mail32@mailinator.com\",\"name\":\"applicant_email\"},{\"value\":\"John Smith\",\"name\":\"applicant_name\"},{\"value\":1143216218,\"name\":\"application_number\"}],\"extract\":true,\"name\":\"Mortgage Loan Agreement\",\"id\":\"loan\",\"data\":{\"esl_doc_extract_type\":1}},{\"fields\":[{\"value\":\"mail33@mailinator.com\",\"name\":\"coapplicant_email\"},{\"value\":\"Patty Galant\",\"name\":\"coapplicant_name\"},{\"value\":1143216218,\"name\":\"application_number\"}],\"extract\":true,\"name\":\"Appraisal Form\",\"id\":\"loan2\",\"data\":{\"esl_doc_extract_type\":1}}]}";

            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            //document 1
            byte[] fileByteArray = File.ReadAllBytes("../mortgage-loan.pdf");
            ByteArrayContent content = new ByteArrayContent(fileByteArray);

            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"mortgage-loan.pdf\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            //document 2
            byte[] fileByteArray2 = File.ReadAllBytes("../appraisal-form.pdf");
            ByteArrayContent content2 = new ByteArrayContent(fileByteArray);

            content2.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content2.Headers.ContentDisposition.Name = "\"file\"";
            content2.Headers.ContentDisposition.FileName = "\"appraisal-form.pdf\"";
            content2.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"mortgage-loan.pdf\"");
            form.Add(content2, "\"file\"", "\"appraisal-form.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");

            var response = myClient.PostAsync(new Uri(url) + "/packages/", form).Result;
            JObject json = JObject.Parse(response.Content.ReadAsStringAsync().Result);

            //setup doc visibility
            string jsonString2 = "{\"configurations\":[{\"documentUid\":\"loan\",\"roleUids\":[\"Signer1\"]},{\"documentUid\":\"loan2\",\"roleUids\":[\"Signer2\"]}]}";
            StringContent jsonContent2 = new StringContent(jsonString2, Encoding.UTF8, "application/json");

            var response2 = myClient.PostAsync(new Uri(url) + "/packages/" + json["packageId"] + "/documents/visibility", jsonContent2).Result;
            Debug.WriteLine(response2.Content.ReadAsStringAsync().Result);

            //send package
            string jsonString3 = "{\"status\":\"SENT\"}";
            StringContent jsonContent3 = new StringContent(jsonString3, Encoding.UTF8, "application/json");

            var response3 = myClient.PutAsync(new Uri(url) + "/packages/" + json["packageId"], jsonContent3).Result;
            Debug.WriteLine(response3.Content.ReadAsStringAsync().Result);

        }
    }
}
